//
//  MyController.m
//  Entfernungsrechner
//
//  Created by Holger Hinzberg on 05.12.09.
//  Copyright 2009 Cocoa Coding. All rights reserved.
//

#import "MyController.h"
#import "City.h"

@implementation MyController

- (id) init
{
    if( self = [super init])
	{
		cityArray = [[NSMutableArray alloc] init];
	}    
	return self;
}

-(void)awakeFromNib
{
    City *aCity = 
	[[City alloc] initWithValues:@"Harsewinke" :8.21463078946776 :51.9718664945271]; 
	[cityArray addObject:aCity];
    [aCity release];
	
	aCity = [[City alloc] initWithValues:@"Schwennigen" :10.6535348271871 :48.6457679042561];
    [cityArray addObject:aCity];
    [aCity release];
	
	aCity = [[City alloc] initWithValues:@"Carlsberg":8.03911829128339: 49.4983469530696];
    [cityArray addObject:aCity];
    [aCity release];
	
	aCity = [[City alloc]initWithValues:@"Fürstenberg":13.1674628105466:53.1915774026942];
    [cityArray addObject:aCity];
    [aCity release];
	
    aCity = [[City alloc]initWithValues:@"Schalksmühle":7.55735388770204:51.2586326002943];
    [cityArray addObject:aCity];
    [aCity release];
	
    aCity = [[City alloc]initWithValues:@"Warstein":8.2960831356548:51.4565752244487];
    [cityArray addObject:aCity];
    [aCity release];
	
    aCity = [[City alloc]initWithValues:@"Bibertal":10.2012115239625:48.3989340288712];
    [cityArray addObject:aCity];
    [aCity release];
		
	for(int i =  0  ; i < [cityArray count] ; i ++)
	{
		City *city = [cityArray objectAtIndex:i];
		[comboCity1 addItemWithObjectValue: [city cityName]];
		[comboCity2 addItemWithObjectValue: [city cityName]];
	} 
	
	[comboCity1 selectItemAtIndex:0];
	[comboCity2 selectItemAtIndex:0]; 

	[comboCity1 setEditable:NO];
	[comboCity2 setEditable:NO]; 

}

- (IBAction)calculateDistance:(id)sender
{
	City *city1 =
	[cityArray objectAtIndex: [comboCity1 indexOfSelectedItem] ];
	
	City *city2 =
	[cityArray objectAtIndex: [comboCity2 indexOfSelectedItem] ];
		
	float city1latitudeArc  = [city1 latitude] /  180 * M_PI;
	float city1longitudeArc = [city1 longitude] / 180 * M_PI;
	
	float city2latitudeArc  = [city2 latitude] /  180 * M_PI;
	float city2longitudeArc = [city2 longitude] / 180 * M_PI; 
	
	float  earthRadius = 6378.137;
	
	double dist = acos(sin(city1latitudeArc) * sin(city2latitudeArc) +
				cos(city1latitudeArc) * cos(city2latitudeArc) *
				cos(city1longitudeArc - city2longitudeArc)) * earthRadius;
	
	NSString *distancestring = [NSString stringWithFormat: @"%.2f", dist];
    [distance setStringValue:distancestring]; 	
}


@end
